%define _default_patch_fuzz 2
%define real_version 552

Name:           cryptopp
Version:        5.5.2
Release:        3%{?dist}
Summary:        Free C++ class library of cryptographic schemes

Group:          System Environment/Libraries
License:        Public Domain
URL:            http://www.cryptopp.com/
Source0:        http://downloads.sourceforge.net/cryptopp/cryptopp%{real_version}.zip
Patch1:         cryptopp-5.5.2-default.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  dos2unix


%description
Crypto++ Library is a free C++ class library of cryptographic schemes. 
Currently the library consists of the following, some of which are other 
people's code, repackaged into classes.

One purpose of Crypto++ is to act as a repository of public domain 
(not copyrighted) source code. Although the library is copyrighted as a 
compilation, the individual files in it (except for a few exceptions listed
in the license) are in the public domain.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        progs
Summary:        Libraries for %{name}
Group:          Applications/System
Requires:       %{name} = %{version}-%{release}

%description    progs
The %{name}-progs package contains cryptest.exe for testing %{name}.


%prep
%setup -q -c
# All files have ^M end of lines, fix that for the makefile patch to apply
find . -type f -exec dos2unix --keepdate {} \;
%patch1 -p1 -b .default


%build
make %{?_smp_mflags} shared \
%ifarch i386
 CFLAGS="$RPM_OPT_FLAGS -fPIC -DPIC -DNDEBUG -DCRYPTOPP_DISABLE_SSE2" \
%else
 CFLAGS="$RPM_OPT_FLAGS -fPIC -DPIC -DNDEBUG" \
%endif

#There is two solutions for fixing ix86 build:
#  either remove -fPIC or use -DCRYPTOPP_DISABLE_SSE2
#Error is:
#vmac.cpp: In member function 'void CryptoPP::VMAC_Base::VHASH_Update_SSE2(const CryptoPP::word64*, size_t, int)':
#vmac.cpp:367: error: can't find a register in class 'GENERAL_REGS' while reloading 'asm'
#vmac.cpp:367: error: 'asm' operand has impossible constraints



%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT LIBDIR=%{_libdir} PREFIX=%{_prefix}
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

ln -sf cryptest.exe $RPM_BUILD_ROOT%{_bindir}/cryptest

%{_fixperms} $RPM_BUILD_ROOT/*


%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc License.txt Readme.txt
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/cryptopp/
%{_libdir}/*.so

%files progs
%defattr(-,root,root,-)
%{_bindir}/cryptest*


%changelog
* Mon Sep 15 2008 kwizart < kwizart at gmail.com > - 5.5.2-3
- Fix i386 build (only) with -DCRYPTOPP_DISABLE_SSE2
- mars.cpp is patented by IBM - Forbidden in Fedora
- Use fixperms macros

* Wed Jul 23 2008 kwizart < kwizart at gmail.com > - 5.5.2-2
- Spec file rewritten
- Make a shared object library with soname 

* Thu Feb 21 2008 Manuel Fombuena <manuel.fombuenazapico [AT] gmail [DOT] com> 5.5.2
- Update to 5.5.2.
- Removed gcc4 and autotols patches.
- Removed optflags replacement.

* Fri Oct 28 2005 Matthias Saou <http://freshrpms.net/> 5.2.1-3
- Include gcc4 patch, and convert all files to UNIX line breaks.

* Tue Nov 16 2004 Matthias Saou <http://freshrpms.net/> 5.2.1-2
- Use optflags, but replace -O? with -O1, since it breaks otherwise.

* Mon Nov 15 2004 Matthias Saou <http://freshrpms.net/> 5.2.1-1
- Update to 5.2.1, with newer patch from Mandrake Cooker.

* Wed May 26 2004 Matthias Saou <http://freshrpms.net/> 5.1-1
- Fedora Core package based on the Mandrake one.

* Mon Mar 01 2004 Lenny Cartier <lenny@mandrakesoft.com> 5.1-1mdk
- from Pierre-Michel Theveny <pmth@free.fr> :
	- Fixed problem with broken library (do not use -O2 !)
	- Added patch for GNU autotools and libtool support
	- Added package progs

* Wed Feb 19 2004 Pierre-Michel Theveny <pmth@free.fr> 5.1-1mdk
- Ported to Mandrake 9.2
- Added shared library

* Tue Feb 18 2004 Ariano Bertacca <ariano@hirnriss.net> 5.1-1
- released libcryptopp-5.1-1
